// $Id: Finger.h 3526 2006-09-12 07:32:21Z vern $
//
// Copyright (c) 1996, 1997, 1998, 1999, 2001, 2002
//      The Regents of the University of California.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that: (1) source code distributions
// retain the above copyright notice and this paragraph in its entirety, (2)
// distributions including binary code include the above copyright notice and
// this paragraph in its entirety in the documentation or other materials
// provided with the distribution, and (3) all advertising materials mentioning
// features or use of this software display the following acknowledgement:
// ``This product includes software developed by the University of California,
// Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
// the University nor the names of its contributors may be used to endorse
// or promote products derived from this software without specific prior
// written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#ifndef finger_h
#define finger_h

#include "TCP.h"

class ContentLine_Analyzer;

class Finger_Analyzer : public TCP_ApplicationAnalyzer {
public:
	Finger_Analyzer(Connection* conn);
	virtual ~Finger_Analyzer()	{}

	virtual void Done();
	// Line-based input.
	virtual void DeliverStream(int len, const u_char* data, bool orig);
	virtual int RewritingTrace()
		{ return rewriting_finger_trace || TCP_ApplicationAnalyzer::RewritingTrace(); }

	static Analyzer* InstantiateAnalyzer(Connection* conn)
		{ return new Finger_Analyzer(conn); }

	static bool Available()	{ return finger_request || finger_reply; }

protected:
	ContentLine_Analyzer* content_line_orig;
	ContentLine_Analyzer* content_line_resp;
	int did_deliver;
};

#endif
